#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>

 
#ifndef ALTPW_LOCATION
#define ALTPW_LOCATION	"/opt/libaltpw/libaltpw.sl"
#endif


void	usage();

void	usage()
{
	printf( "Usage: runalpw /FULL/PATH/TO/PASSWD /FULL/PATH/TO/EXEC EXEC ARGS\n" );
	exit( 1 );
}


#ifdef __hpux
int setenv(name, value)
char *name;
char *value;
{
    char *cp, *malloc();

    if ((cp = malloc((unsigned)(strlen(name)+strlen(value)+2)))) {
        sprintf(cp, "%s=%s", name, value);
        return(putenv(cp));
    } else {
        return(0);
    }
}
#endif





int main( int argc, char *argv[] )
{
	/* Takes progname altpwfile */
	char	*altpw = argv[ 1 ];
	char	*prog = argv[ 2 ];
	struct stat	stbuf;

	if( argc < 3 )
	{
		usage();
	}

	/* argv[ argc ] = NULL; */

	if( prog[ 0 ] != '/' )
	{
		usage();
	}

	if( altpw[ 0 ] != '/' )
	{
		usage();
	}

	/* OK, check if the exec is SUID, that'll ignore our PRELOAD */
	if( stat( prog, &stbuf ) == -1 )
	{
		printf( "Unable to stat %s\n", prog );
		return( 1 );
	}

	if( stbuf.st_mode & S_ISUID )
	{
		printf( "Executable is SUID, will not work with LD_PRELOAD\n" );
		return( 1 );
	}

	if( stat( altpw, &stbuf ) == -1 )
	{
		printf( "Unable to stat %s\n", altpw );
		return( 1 );
	}

	/* Make sure we can SEE the library */
	if( stat( ALTPW_LOCATION, &stbuf ) == -1 )
	{
		printf( "Unable to stat library: %s\n", ALTPW_LOCATION );
		exit( 1 );
	}

	/* Ready to do the hoopajoo!  Fill in the environment and exec */
	setenv( "LD_PRELOAD", ALTPW_LOCATION, 1 );
	setenv( "ALTPASSWD", altpw, 1 );
	execvp( prog, &argv[ 2 ] );

	perror( "Unable to exec" );

	return( 0 );
}
